VERSION 2.00
Begin Form IDOPEN 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "DlgDirList File Open"
   ClientHeight    =   2490
   ClientLeft      =   2670
   ClientTop       =   1845
   ClientWidth     =   4875
   Height          =   2895
   Left            =   2610
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2490
   ScaleWidth      =   4875
   Top             =   1500
   Width           =   4995
   Begin ListBox DList 
      Height          =   1395
      Left            =   2040
      TabIndex        =   7
      Top             =   850
      Width           =   1455
   End
   Begin ListBox FList 
      Height          =   1395
      Left            =   240
      TabIndex        =   5
      Top             =   850
      Width           =   1575
   End
   Begin CommandButton OkCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Index           =   1
      Left            =   3735
      TabIndex        =   3
      Top             =   675
      Width           =   975
   End
   Begin CommandButton OkCancel 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Index           =   0
      Left            =   3720
      TabIndex        =   2
      Top             =   180
      Width           =   975
   End
   Begin Label Label5 
      Caption         =   "&Directories:"
      Height          =   255
      Left            =   2040
      TabIndex        =   6
      Top             =   600
      Width           =   1095
   End
   Begin Label Label4 
      Caption         =   "&Files:"
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   600
      Width           =   615
   End
   Begin Label PName 
      Height          =   195
      Left            =   1200
      TabIndex        =   1
      Top             =   240
      Width           =   2355
   End
   Begin Label Label2 
      Caption         =   "Directory:"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   855
   End
End
DefInt A-Z

Declare Function DlgDirList Lib "User" (ByVal hDlg As Integer, ByVal lpPathSpec As String, ByVal nIDListBox As Integer, ByVal nIDStaticPath As Integer, ByVal wFiletype As Integer) As Integer
Declare Function DlgDirSelect Lib "User" (ByVal hDlg As Integer, ByVal lpString As String, ByVal nIDListBox As Integer) As Integer
Declare Function SetErrorMode Lib "Kernel" (ByVal wMode As Integer) As Integer

' IDs of the controls we'll be needing
Const IDS_PATH = 3
Const IDL_FLIST = 7
Const IDL_DLIST = 8

' search spec
Const sFileSpec = "*.*"

' last change flags
Const FListBox = 1
Const DListBox = 2

' iChange holds the last change flag
Dim iChange As Integer

'  sCurDir holds the most recent directory
Dim sCurDir As String

Sub DList_Click ()
    iChange = DListBox
End Sub

Sub DList_DblClick ()

    ' Prepare a buffer to hold the new directory
    aDir$ = String$(15, 0)

    ' get the new directory
    Ok = DlgDirSelect(IDOPEN.hWnd, aDir$, IDL_DLIST)

    ' get rid off the Chr$(0)s
    aDir$ = Left$(aDir$, InStr(aDir$, Chr$(0)) - 1)

    ' let Windows handle the errors, e.g. drive not ready, etc
    iErrMode = SetErrorMode(0)

    ' perform the changes
    Ok = DlgDirList(IDOPEN.hWnd, (aDir$ + sFileSpec), IDL_FLIST, IDS_PATH, 0)
    Ok = DlgDirList(IDOPEN.hWnd, "*.*", IDL_DLIST, 0, &HC010)

    ' give error control back to us
    iErrMode = SetErrorMode(1)

    ' save the directory change
    sCurDir = LCase$(MakePath$(CurDir$))

End Sub

Sub FList_Click ()
    iChange = FListBox
End Sub

Sub FList_DBlClick ()

    ' if there is a selection, retrieve it and change the IDDEMO
    ' FName caption to show the full selection

    If FList.ListIndex <> -1 Then
	IDDEMO.FName.Caption = sCurDir + FList.List(FList.ListIndex)
	IDOPEN.Hide
    End If

End Sub

Sub Form_Load ()
    
    ' fill the listboxes (wFileSpec is set to 0 for normal files)
    
    Ok = DlgDirList(IDOPEN.hWnd, sFileSpec, IDL_FLIST, IDS_PATH, 0)

    Ok = DlgDirList(IDOPEN.hWnd, "*.*", IDL_DLIST, 0, &HC010)
    
    ' save the current directory
    sCurDir = LCase$(MakePath$(CurDir$))

End Sub

Function MakePath$ (aPath$)

    If Right$(aPath$, 1) <> "\" Then
	MakePath$ = aPath$ + "\"
    Else
	MakePath$ = aPath$
    End If

End Function

Sub OkCancel_Click (Index As Integer)
    If Index = 0 Then
	Select Case iChange
	    Case DListBox
		DList_DblClick
	    Case FListBox
		FList_DBlClick
	    Case Else
	End Select
    Else
	IDOPEN.Hide
    End If
End Sub

